
import javax.swing.*;

abstract class AbstractController {
  SequencingParameters seqParms;
  boolean bwdSequence;

  abstract void message(String s);
  abstract void debugmessage(String s);

  abstract void mousePosition(double x, double y);
  abstract void mousePosition();
  
  abstract void setSpectrumChanged();
  abstract void setSpectrum(Spectrum spectrum);

  abstract Sequences newSequences();
  abstract void showSeq();
  abstract String getSeqOut();
  abstract void setDelta(String s);

  abstract Proposal currentProposal(boolean left);
  abstract void showProposal(int npi);
  abstract boolean proposalValid();
  abstract void resetProposal();

  abstract void registerSpectrumWindow(Object sw);

  abstract void setSeqParmsChanged(Object o);

  abstract Action getUndoAction();
  abstract Action getRedoAction();
  abstract void checkPoint();
  abstract void clearUndoStack();
}
