
import java.io.*;
import java.util.*;

/**
 * Support for logging of constructed sequences
 */
class Log {
  private ArrayList log = new ArrayList();
  private boolean unsaved = false;

  public void write(String s) {
    log.add(s);
    unsaved = true;
  }

  public void writeFile(String filename, AbstractController controller) {
    try {
      PrintWriter pw = new PrintWriter(new FileWriter(filename));
      Iterator iter = log.iterator();
      while (iter.hasNext()) 
	pw.println(iter.next());
      pw.close();
      controller.message("Wrote log to file: " + filename);
      unsaved = false;
    } catch (IOException exn) {
      controller.message("IO error: " + exn);
    }
  }

  public boolean getUnsaved() { return unsaved; }
}
