
import java.awt.*;
import javax.swing.*;

/**
 * A simple console output window for showing debug info
 */
class LogFrame extends JFrame{
  private JScrollPane jsp;
  private JTextArea msgArea;
  private boolean notEmpty;
  
  LogFrame(String title, boolean exitOnClose) {
    super(title);
    setDefaultCloseOperation(exitOnClose ? 
			     JFrame.EXIT_ON_CLOSE : 
			     JFrame.HIDE_ON_CLOSE);
    msgArea = new JTextArea(25,80);
    msgArea.setFont(new Font("Monospaced",Font.PLAIN,12));
    msgArea.setEditable(false);
  }
  
  public void message(String msg, boolean doPopup) {
    if (notEmpty)
      msgArea.append("---------------\n");
    else
      notEmpty = true;
    msgArea.append(msg);
    if (!msg.endsWith("\n"))
	msgArea.append("\n");
    if (doPopup) 
      popup();
    msgArea.setCaretPosition(msgArea.getDocument().getLength());
  }


  private boolean seen;
  public void popup() {
    //We defer pack() to just before shown for the first time!
    if (!seen) {
      jsp = new JScrollPane(msgArea,
			    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
			    JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
      getContentPane().add(new Label("Log:"),BorderLayout.NORTH); 
      getContentPane().add(jsp,BorderLayout.WEST);
      pack();
      seen = true;
    }
    setVisible(true);
    setState(Frame.NORMAL);
  }
}


