
import java.util.*;

/**
 * return type of ProposalAlgo methods
 */
class Proposal implements Comparable {
  private static int nextid;
  private int id;
  private LinkedList /*of AcidWithPeak*/ proposal;
  final double score;

  Proposal(LinkedList proposal, double score) {
    id = nextid++;
    this.proposal = proposal;
    this.score = score;
  }
  
  Iterator iterator() {
    return proposal.iterator();
  }

  public int compareTo(Object o) {
    Proposal other = (Proposal)o;
    return score<other.score ? 1 : score>other.score ? -1 : id-other.id;
  }

  public String toString() {
    StringList res = new StringList();
    Iterator iter = iterator();
    while (iter.hasNext()) {
      AcidWithPeak awp = (AcidWithPeak)(iter.next());
      if (awp.acid != null)
	res.add(awp.acid.abbr);
      //      res.add("("+awp.peak.x+")");
    }
    return res.toStringBuffer(false).toString()+" ["+score+"]";
  }
}
