/**
 * What a proposal algorithm should implement
 */
interface ProposalAlgo {
  //Return proposal of rank going in direction left starting in peak obs[i]
  //This only makes sense relative to a given spectrum!
  Proposal getProposal(int i, boolean left, int rank);
  String getSequence(int i, boolean left, int rank, boolean bwdSequence);
  String getSequence(int i, int lr, int rr,boolean bwdSequence);
  int getProposalCount(int i, boolean left);
  /**
   * How to get feedback from DenovoDP. Part of the interface
   * implemented by ProgressMonitor.
   */
  interface Feedback {
    boolean isCanceled();
    void setMaximum(int m);
    void setProgress(int nv);
  }
}
