
interface Score {
  /*
  Score add(Peak p, AminoAcid acid, double mass_error);
  Score makenew(Peak p);
  double score();
  */
  //It is a little cheating to let Score transport these around:
  
  double getGrass();
  double getTolerance();
  boolean getIndependentErrors();
  boolean getAllowDuplicatePeaks();

  //peakscore is the mass-independent penalty for the abundance
  double peakscore(Peak p);

  //acidscore contains the premium for adding an acid (1 if beta=0)
  //and the penalties for mass misfit and the KRcorrection at the end.
  //We need p1 or p2 for checking the end condition. If
  //independent_errors is false we need mass_error (or a predicted
  //mass) else we could do with p1 and p2.
  double acidscore(AminoAcid a, double mass_error, Peak p1, Peak p2);

  //We would only call acidscore to plumb the whole in a SequencePair,
  //while the rest of chenlike() and denovodp would use
  double stepscore(AminoAcid a, double mass_error, Peak p1, Peak p2);
  //that simply does peakscore(p1)+acidscore(...)
}
