//Scoring sequences
/**
 *  A package of parameters for scoring a sequence.
 */

class SequencingParameters implements Cloneable {
  //Values in initializers are "Factory defaults"
  //
  // Hard cutoff parameters
  double tolerance = 0.5;//Potential aa tolerance in amu
  double grass = 0.003;// *maxAbundance= cutoff for low peaks
  boolean independent_errors = true;

  double expectedCount = 20.0; //SIC!
  double sigma = 0.150;
  double lambda = 1.0;
  double nu = 0.040;
  double beta = 0;
  double krpenalty = 1.0;
  boolean allowKR = false;
  boolean allowDuplicatePeaks = false; //When spectrum.isMirrored  
  

  public String toHTML() {
    return
      "<tr><td><b>Tolerance</b><td>" + tolerance + 
      "<tr><td><b>Grass</b> <td>" + grass +
      "<tr><td><b>sigma</b><td>" + sigma + 
      "<tr><td><b>lambda</b><td>" + lambda + 
      "<tr><td><b>nu</b><td>" + nu + 
      "<tr><td><b>beta</b><td>" + beta + 
      "<tr><td><b>krpenalty</b> <td>" + krpenalty +
      "<tr><td><b>Allow K&R</b> <td>" + allowKR;
  }
  public SequencingParameters save() {
     SequencingParameters newp = null;
    try { 
      newp = (SequencingParameters)super.clone();
    } catch (CloneNotSupportedException ex){}
    return newp;
  }
  public void restore(SequencingParameters sav) {
    //This should be implemented using java.lang.reflect
    tolerance = sav.tolerance;
    grass = sav.grass;
    expectedCount = sav.expectedCount;
    sigma = sav.sigma;
    lambda = sav.lambda;
    nu = sav.nu;
    beta = sav.beta;
    krpenalty = sav.krpenalty;
    allowKR = sav.allowKR;
  }

}

