
import java.awt.*;
import java.awt.geom.*;
import java.text.*;
import java.util.*;
import javax.swing.*;

/**
 * A red triangular mark, pointing down, with the point in (x, y)
 */
class Triangle extends Mark {
  final static private int[] xs = {  -5,   5, 0 };
  final static private int[] ys = { -10, -10, 0 };
  final static private GeneralPath triangle = new GeneralPath();

  static {
    triangle.moveTo(xs[0],ys[0]);
    for (int i=1; i<xs.length; i++) 
      triangle.lineTo(xs[i],ys[i]);
    triangle.closePath();
  }

  public Triangle(double x, double y, Peak peak, AbstractSequence seq) {
    this.x = x; this.y = y; this.peak = peak; this.kind = Mark.START;
    this.seq = seq;
  } 

  void drawInner(Graphics2D g, AbstractCoordinates coor, 
		 double tolerance, boolean showErrors) {
    g.setColor(Color.red);
    AffineTransform t = AffineTransform.getTranslateInstance(coor.fromX(x),
							     coor.fromY(y));
    g.fill(triangle.createTransformedShape(t));
  }

  public String getAbbr() { 
    return "";
  }
  
  public void remove() {
    seq.remove();
  }
}
