//----------------------------------------------------------------------------
//MASS SCALING

    /* bad idea
    //Part of a least-squares estimation
    public void estimateKappa(double[] out) {
      estimateKappa(out, true);
      estimateKappa(out, false);
    }
    //Let the tentative scaleFactor be currentScaleFactor + rho
    //
    //Then peaks scale as peak.x(rho) = peak.x + delta(peak)*rho,
    //where delta(peak) =
    //      peak.x_orig    if peak.kind = ORIGINAL
    //      totalMass_orig-peak.x_orig   if peak.kind = MIRRORED
    // (wrong)   peak.x_orig*peak.trans.getFactor() if  peak.kind = TRANSFORMED
    //      0              if peak.kind = SYNTHETIC_BOTTOM
    //      totalMass_orig if peak.kind = SYNTHETIC_TOP
    //
    //Marks scales as follows: the start mark follows its peak and the
    //rest moves along by translation
    //
    //The total squaresum of errors are then 
    //sum(sqr(m_j(rho)-p_j(rho))) = 
    // sum(sqr(error_j(0)+(delta_0-delta_j)*rho))

    private double delta(Peak p) {
      switch(p.kind) {
      case Peak.ORIGINAL:
	return p.x_orig;
      case Peak.MIRRORED:
	return spectrum.totalMass_orig-p.x_orig;
      case Peak.TRANSFORMED:
	return 
	  p.iontype.mapToY(p.x_orig, spectrum.totalMass_orig) - 
	  p.iontype.mapToY(0,0);
      case Peak.SYNTHETIC_BOTTOM:
	return 0;
      case Peak.SYNTHETIC_TOP:
	return spectrum.totalMass_orig;
      default:
	return 0;
      }
    }
    //
    //out[1] = sum(sqr(delta(p_j)-delta(p_0)), j=1..size)
    //out[0] = sum(error_j*(delta(p_j)-delta(p_0)),j=1..size)
    //So 
    private void estimateKappa(double[] out, boolean left) {
      LinkedList list = left ? acceptedL : acceptedR;
      Peak startPeak = ((Mark)(list.getLast())).peak;
      double delta_0 = delta(startPeak);
      Iterator iter = list.iterator();
      while (iter.hasNext()) {
	Mark m = (Mark)(iter.next());
	double delta_diff = delta_0 - delta(m.peak);
	out[0] += (m.x-m.peak.x)*delta_diff;
	out[1] += delta_diff*delta_diff;
      }
    }
    //The scaling is actually just a translation of the marks so that
    //the start mark follows it peak:
    public void scale(double kappa) {
      double scaleFactor = 1.0+kappa/1000.0;
      Mark startmark = (Mark)(acceptedL.getLast());
      double mass_delta = startmark.peak.x - startmark.x;
      Iterator iter = acceptedL.iterator();
      while (iter.hasNext()) 
	((Mark)(iter.next())).x += mass_delta;
      iter = acceptedR.iterator();
      while (iter.hasNext()) 
	((Mark)(iter.next())).x += mass_delta;
      startmark.x -= mass_delta;
    }

    */

  /**
   * Scale the original masses of spectrum by kappa permille. 
   *
   * We also scale totalMass! (Assumes same error)
   * 
   * was a bad idea!
  Spectrum scale(double kappa) {
    double scaleFactor = 1+kappa/1000;
    TreeSet newobs = new TreeSet();
    double newTotalMass =  scaleFactor * totalMass_orig;
    for (int i=0; i<obs.length; i++) {
      Peak p = obs[i];
      if (p.kind == Peak.SYNTHETIC_BOTTOM )
	newobs.add(p);
      else if (p.kind == Peak.SYNTHETIC_TOP ) {
	p.x = IonType.B.mapToY(IonType.B.toMZ(0),newTotalMass);
	newobs.add(p);
      }
      else if (p.kind == Peak.ORIGINAL ) {
	p.x = scaleFactor * p.x_orig;
	newobs.add(p);
      }
      else if (p.kind == Peak.MIRRORED) { 
	p.x = IonType.B.mapToY(scaleFactor*p.x_orig, newTotalMass);
	newobs.add(p);
      }
      else if (p.kind == Peak.TRANSFORMED) { 
	p.x = p.iontype.mapToY(scaleFactor * p.x_orig, newTotalMass);
	newobs.add(p);
      }
      else 
	throw new IllegalArgumentException();
    }
    Spectrum newspectrum = new Spectrum(name, origPeakCount, 
					newTotalMass, totalMass_orig,
					chargeState, newobs, false);
    newspectrum.isMirrored = isMirrored; //Should be part of constructor?
    return newspectrum;
  }

  */

  //-----------------------------------------------------------------
  // Mass correction
  /* was a bad idea
  public void setMassCorrectionFrame(MassCorrectionFrame mcf) {
    masscorrFrame = mcf;
  }

  public double estimateKappa() {
    double oldScaleFactor = spectrum.totalMass/spectrum.totalMass_orig;
    if (sequences != null)
      return sequences.estimateKappa(oldScaleFactor);
    return 0;
  }
  */

  /*
   * scale spectrum and sequences 
   *
   * commented out - was a wrong idea

  public void scaleSpectrum(double kappa) {
    setSpectrum(spectrum.scale(kappa),false);
    sequences.scale(kappa);
  }
  */

  /*
   * Estimate the mass error from constructed sequences:
   *
   * bad idea
  public double estimateKappa(double oldScaleFactor) {
    Iterator iter = sequences.iterator();
    double[] out = new double[2];
    //    double real=0.0, measured=0.0;
    while (iter.hasNext()) {
      Sequence seq = ((Sequence)iter.next());
      seq.estimateKappa(out);
    }
    if (out[1]>0) 
      return  1000.0*(oldScaleFactor - out[0]/out[1] - 1);
    else 
      return 0.0;
  }

  public void scale(double kappa) {
    Iterator iter = sequences.iterator();
    while (iter.hasNext()) {
      Sequence seq = ((Sequence)iter.next());
      seq.scale(kappa);
    }
  }
  */

  /* bad idea
  public void scaleSpectrum(double kappa) {
    sw.scaleSpectrum(kappa);
  }
  */

/*
class MassCorrectionFrame extends LockableJFrame {
  private final static DecimalFormat fmt3 = new DecimalFormat("0.000");
  private DPSlider 
    kappaSb;
  private JPanel outerP;
  private JButton estimateB, setB, resetB;
  private GridBagConstraints lblC,sbC,txtC;

  public void resetKappa() {
    kappaSb.setValue(0.0);
  }

  class DPSlider {
    private JSlider sb;
    private JTextField tf;
    double bot, top;
    int marks;
    DPSlider(String label, final double bot, 
		final double top, final int marks) {
      this.bot = bot;
      this.top = top;
      this.marks = marks;
      outerP.add(new JLabel(label), lblC);
      outerP.add(sb = new JSlider(JSlider.HORIZONTAL,0,marks,0),sbC);
      tf = new JTextField(5) {
	  public boolean isFocusTraversable() {
	    return false;
	  }
	};
      outerP.add(tf, txtC);
      tf.setEditable(false);
      sb.addChangeListener(new ChangeListener() {
	  public void stateChanged(ChangeEvent e) {
	    tf.setText(fmt3.format(bot+ sb.getValue()*(top-bot)/marks));
	  }
	});
    }
    double getValue() {
      return fmt3.parse(tf.getText(), new ParsePosition(0)).doubleValue();
    }
    void setValue(double val) {
      sb.setValue((int) ( marks * (val - bot) / (top-bot)));
      tf.setText(fmt3.format(val));
    }
    void setEnabled(boolean b) {
      sb.setEnabled(b);
    }
  }
    
  MassCorrectionFrame(final Controller controller) {
    super("KVL AminoSequencer: Mass correction");
    setDefaultCloseOperation(HIDE_ON_CLOSE);
    controller.setMassCorrectionFrame(this);
    outerP = new JPanel();
    outerP.setLayout(new GridBagLayout());
    lblC = new GridBagConstraints();
    lblC.weightx = 0.1;
    lblC.anchor = GridBagConstraints.WEST;
    lblC.insets = new Insets(1, 1, 1, 1);
    lblC.gridwidth = GridBagConstraints.WEST;
      
    sbC = (GridBagConstraints) lblC.clone();
    sbC.weightx = 1.0;
    sbC.fill = GridBagConstraints.HORIZONTAL;

    txtC = (GridBagConstraints) lblC.clone();
    txtC.anchor = GridBagConstraints.EAST;
    txtC.gridwidth =  GridBagConstraints.REMAINDER;

    kappaSb = new DPSlider("\u03ba mass korrection(in permille)", //\u2030
			   -5.0, 5.0, 10000);

    JPanel cP = new JPanel();
    cP.setLayout(new FlowLayout());
    cP.add(estimateB = new JButton("Estimate"));
    cP.add(setB = new JButton("Set"));
    cP.add(resetB = new JButton("Reset"));
    outerP.add(cP,lblC);
    JPanel foo = new JPanel();
    foo.setPreferredSize(new Dimension(200,1));
    outerP.add(foo,sbC);
    setDefaults();
    getContentPane().add(outerP);

    estimateB.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent ev) {
	  double est_kappa = controller.estimateKappa();
	  kappaSb.setValue(est_kappa);
	}
      });

    setB.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent ev) {
	  controller.scaleSpectrum(kappaSb.getValue());
	}
      });
      
    resetB.addActionListener(new ActionListener() {
	public void actionPerformed(ActionEvent ev) {
	  setDefaults();
	}
      });
  }

  void setDefaults() {
    kappaSb.setValue(0.0);
  }

}
*/

      // Settings | mass correction
      /* bad idea
      JMenuItem massCorr = new JMenuItem("Mass correction ...");
      settingsMenu.add(massCorr);
      massCorr.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent e) {
	    //This should not be necessary or even to do each time:
	    masscorrFrame.pack();
	    masscorrFrame.setVisible(true);
	    masscorrFrame.setState(Frame.NORMAL);
	  }
	});
      */

//---------------------------------------------------------------------------
//ReinterpretOptimal

	  /* optimal reinterpretation was a hopeless idea
	  if (!spectrum.isMirrored) {
	    //This action should also be present in menubar
	    popup.add(new AbstractAction("Optimal reinterpretation") {
		public void actionPerformed(ActionEvent e) {
		  sequences.clear();
		  spectrum.removeReinterpretations(sequences);
		  spectrum.reinterpretOptimal();
		  setParams();
		  setPotential();
		  controller.showSeq();
		  controller.setSpectrumChanged();
		  repaint();
		}
	      });
	  }
	  */


  /*
  //SHERENGA style lal: Always much worse results!!
  public void reinterpretOptimal() {
    //First, build a local abundance level composed of all possible
    //reinterpretations within tolerance: An important design choice
    //is how to superimpose the (reinterpreted) peaks. For the moment
    //we sum p.y/p.la. One might as well just sum p.y or make some
    //other scaling. The ideal would be to have a
    //(probability)theoretical model. One should definitely weight the
    //various reinterpretations according to probabilities of
    //generating the ion types.
    double sherenga_tolerance = 0.5;
    double[] sherenga;
    double max_sherenga;
    sherenga = new double[(int)(totalMass/sherenga_tolerance)+1];
    max_sherenga = Double.NEGATIVE_INFINITY;
    ITA[] s_obs = (ITA [])ionTypeAlternatives.toArray(new ITA[0]);
    int lowindex = 0;
    int index = -1;
    int highindex = 0;
    double lal = 0.0;
    IonType y_ion = IonType.Y;
    IonType b_ion = IonType.B;
    while (++index < sherenga.length) {
      double w = index*sherenga_tolerance;
      double wplus = w+sherenga_tolerance;
      double wminus = w-sherenga_tolerance;
      while (highindex < s_obs.length && s_obs[highindex].w < wplus) {
	ITA ita = s_obs[highindex++];
	if (ita.p.ignore)
	  continue;
	double weight = ita.iontype==y_ion ? 1 : ita.iontype==b_ion ?0.5:0.25;
	lal += weight*Math.max(ita.p.y-ita.p.lb,0)/ita.p.la;
      }
      while (lowindex < s_obs.length && s_obs[lowindex].w < wminus) {
	ITA ita = s_obs[lowindex++];
	if (ita.p.ignore)
	  continue;
	double weight = ita.iontype==y_ion ? 1 : ita.iontype==b_ion ? 0.5:0.25;
	lal -= weight*Math.max(ita.p.y-ita.p.lb,0)/ita.p.la;
      }
      sherenga[index] = lal;
      max_sherenga = Math.max(max_sherenga,lal);
    }
    //Now, for each peak in spectrum, select the reinterpretation with
    //the largest
    //sherenga[(int)(iontype.mapToY(p.x,totalMass)/sherenga_tolerance)]
    //
    //Note that we so far assume no reinterpretations have been done
    //and no sequences have been created (could call
    //removeInterpretations)
    for (int i=0; i<obs.length; i++) {
      if (obs[i].orig_index<0)
	continue;
      Peak p = obs[i];
      double maxs = Double.NEGATIVE_INFINITY;
      IonType best_iontype = null;
      Iterator iter = IonType.iterator();
      while (iter.hasNext()) {
	IonType iontype = (IonType)(iter.next());
	int j = (int)(iontype.mapToY(p.x,totalMass)/sherenga_tolerance+0.5);
	if (j<0 || j>= sherenga.length)
	  continue;
	double s = sherenga[j];//*(iontype==y_ion?1:iontype==b_ion ?0.5:0.25);
	if (s>maxs) {
	  maxs = s;
	  best_iontype = iontype;
	}
      }
      if (best_iontype == null)
	continue;
      p.x = best_iontype.mapToY(p.x, totalMass);
      p.kind = best_iontype == y_ion ? 	Peak.ORIGINAL :	Peak.TRANSFORMED;
      p.iontype = best_iontype==y_ion ? null : best_iontype;
    }
    Arrays.sort(obs);
  }
  */


//---------------------------------------------------------------------------

/*
//----------------------------------------------------------------
//Local DP: try to construct a better set of classes This would be an
//alternative to DenovoDP that computes candidates starting at a
//specific point on demand. It is not in sync with the interfaces.

class LocalCandidate {
  int maxAcids = 5; //random default
  int maxCandidates = 10; //do.
  Spectrum spectrum;
  int startIndex;
  boolean left; //Is this a leftwards candidate

  EndpointQ bestCandidates;

  int lastEPid; //For this LocalCandidate
  class Endpoint implements Comparable {
    int id;        //To make ordering total
    int index;     //Index in spectrum.obs
    Endpoint prev;  //Index in spectrum.obs of previous peak
    AminoAcid acid;      //The acid of the interval there
    Score score;
    Endpoint(int i, Endpoint ep, AminoAcid a, Score s) {
      id = lastEPid++;
      index = i;
      prev = ep;
      acid = a;
      score = s;
    }
    public int compareTo(Object o) {
      //Invert the sign so that the higher scoring elements comes first
      int score_rel = -score.compareTo(((Endpoint) o).score);
      //if the scores happens to be equal, prefer (arbitrarily) the
      //element created first
      return score_rel != 0 ? score_rel : id - ((Endpoint) o).id;
    }
    public String toString() {
      StringBuffer res = new StringBuffer(score.score() 
					  + "("+spectrum.obs[index].x+")");
      Endpoint ep = prev;
      AminoAcid a = acid;
      while (ep != null) {
	res.append(a.abbr + "("+spectrum.obs[ep.index].x+")");
	a = ep.acid;
	ep = ep.prev;
      }
      return res.toString();
    }
  }

  //Find the best sequences starting in startPeak, going
  //left?"left":"right", avoiding already constructed sequences.

  public LocalCandidate(Spectrum spectrum,
			Sequences sequences, //peak(interval)s to avoid 
			int startIndex,
			boolean left,
			double mass_tolerance, 
			double grass,
			Score score) {
    this.spectrum = spectrum;
    this.startIndex = startIndex;
    this.left = left;
    int side = left ? -1 : +1;
    //renormalize
    double a_limit = spectrum.maxAbundance*grass;
    Peak[] obs = spectrum.obs;
    AminoAcid[] sortedAcids = 
      (AminoAcid[]) AA.aaByMonoW.toArray(new AminoAcid[0]);
    double mass_limit;
    int index_limit;
    if (sequences != null) 
      throw new IllegalArgumentException("Not implemented");
    else {
      mass_limit = left ? 0.0 : spectrum.totalMass;
      index_limit = left ? 0 : obs.length-1;
    }
    bestCandidates = new EndpointQ(maxCandidates);
    EndpointQ[] localBestCandidates = new EndpointQ[maxAcids+1];
    //
    int acids = 0;
    localBestCandidates[0] = new EndpointQ(maxCandidates);
    Score s0 = score.makenew(obs[startIndex]);
    localBestCandidates[0].add(new Endpoint(startIndex,null,null,s0));
    //
    while (acids < maxAcids) {
      Iterator iter = localBestCandidates[acids].iterator();
      acids++;
      localBestCandidates[acids] =  new EndpointQ(maxCandidates);
      while (iter.hasNext()) {
	Endpoint ep = (Endpoint) iter.next();
	int local_index_limit = ep.index;
	//Check amino acids in increasing weight order
	for (int a=0; a<sortedAcids.length-1; a++) {
	  AminoAcid acid = sortedAcids[a];
	  double monoW = acid.monoW;
	  double w = obs[ep.index].x + side * (monoW - mass_tolerance);
	  if (side*(mass_limit - w) > 0) {//else no room
	    //Binary search 
	    int far = index_limit;
	    int near = local_index_limit;
	    do {
	      int r = (far+near)/2;
	      if (side*(obs[r].x - w)>0 )
		far = r;
	      else 
		near = r;
	    } while ( side*(far - near) > 1 );
	    //First peak-index at least as near as w
	    local_index_limit = near;
	    //Check candidates (linear search). We accept all peaks in
	    //tolerance interval with abundance above threshold
	    int j = local_index_limit;
	    while (side*(obs[j].x-w) <= 2*mass_tolerance) {
	      if (obs[j].y > a_limit) {
		//We should avoid orig_indexes listed in sequences
		double mass_error = obs[ep.index].x-obs[j].x+side*monoW;
		Score newscore =ep.score.add(obs[j], acid, mass_error);
		Endpoint newep = new Endpoint(j, ep, acid, newscore);
		localBestCandidates[acids].add(newep);
	      }
	      j += side ;
	    }
	  }
	}
      }
    }
    for (int ai=0;ai<=maxAcids; ai++)
      bestCandidates.addAll(localBestCandidates[ai].toArray());
    Iterator iter = bestCandidates.iterator();
    while (iter.hasNext())
      System.out.println((Endpoint)iter.next());
  }

  //Utility subclass of TreeSet for easy bookkeeping
  class EndpointQ {
    private TreeSet tree;
    private int maxRank;
    EndpointQ(int N) {
      maxRank = N;
      tree = new TreeSet();
    }
    void add(Endpoint tb) {
      if (tree.size() == maxRank) {
	Endpoint last = (Endpoint) tree.last();
	if (tb.compareTo(last) < 0) 
	  tree.remove(last);
	else 
	  return;
      }
      tree.add(tb);
    } 
    void addAll(Endpoint[] tbs) {
      if (tbs !=null)
	for (int i=0; i<tbs.length; i++)
	  add(tbs[i]);
    }
    Endpoint[] toArray() {
      if (tree.size() == 0) 
      return new Endpoint[0];
      Endpoint[] res = new Endpoint[tree.size()];
      tree.toArray(res);
      return res;
    }
    Iterator iterator() {
      return tree.iterator();
    }
  }
}
*/

//-----------------------------------------------------------------
// total mass test

  /*
  //This only makes sense on original spectrum. Compute all masses
  //near totalMass:
  public void tmtest() {
    int i = -1;
    int highindex = obs.length-1; 
    int count = 0;
    double tol = 0.5; !!!
    double[] z = new double[200];
    while (++i <= highindex) {
      if (obs[i].orig_index<0) 
	continue;
      double limit = totalMass-obs[i].x+tol;
      while (obs[highindex].x > limit)
	highindex--;
      if (i>highindex)
	break;
      limit = totalMass-obs[i].x-tol;
      int j = highindex;
      while (obs[j].x >= limit) {
	int x = (int)(z.length*((obs[j].x+obs[i].x)-(totalMass-tol))/(2*tol));
	z[x] += obs[j].y*obs[i].y;//Math.max(0,Math.log(obs[j].y*obs[i].y));
	//out.println((obs[j].x+obs[i].x)+" "+Math.log(obs[j].y*obs[i].y));
	j--; //limit will never be less than totalMass/2-tol
      }
    }
    //
    System.out.println(""+totalMass);
    try {
      PrintWriter out = new PrintWriter(new FileOutputStream("a.dat"));
      for (int x=0; x<z.length; x++) 
	out.println((x*((2*tol)/z.length) + totalMass-tol)+" "+z[x]);
      out.close();
    }
    catch(FileNotFoundException ex) {};
  }
  */

